/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Carrier.Paazl {
  
  export class PaazlDeliveryDateDetail {
    Day : string; // DateTime
    Period : EVA.Carrier.Paazl.PaazlPeriod; 
  }
  
  export class PaazlGetShippingOptionsForOrder extends EVA.API.RequestMessageGeneric<EVA.Carrier.Paazl.PaazlGetShippingOptionsForOrderResponse> {
    OrderID : number; // Int32
    ExtendedDeliveryDateDetails : boolean; 
  }
  
  export class PaazlGetShippingOptionsForOrderResponse extends EVA.API.GetListResponse<EVA.Carrier.Paazl.PaazlShippingOption> {
  }
  
  export class PaazlOpeningHours {
    DayOfWeek : number; // Int32
    AlwaysOpen : boolean; 
    Period : EVA.Carrier.Paazl.PaazlPeriod; 
  }
  
  export class PaazlPeriod {
    From : any; // TimeSpan
    Till : any; // TimeSpan
  }
  
  export class PaazlShippingAddress {
    Type : string; 
    Code : string; 
    StreetAndHouseNumber : string; 
    ZipCode : string; 
    City : string; 
    CountryID : string; 
    Latitude : number; // Decimal
    Longitude : number; // Decimal
    Distance? : number; // Decimal, nullable
    Price? : number; // Decimal, nullable
    DisplayPrice? : number; // Decimal, nullable
    AdditionalInfo : string; 
    OpeningHours : EVA.Carrier.Paazl.PaazlOpeningHours[]; 
  }
  
  export class PaazlShippingOption {
    Type : string; 
    Carrier : string; 
    Description : string; 
    Price? : number; // Decimal, nullable
    DisplayPrice? : number; // Decimal, nullable
    PartOfDay : string; 
    DayOfWeek : string; 
    DeliveryDateDetails : EVA.Carrier.Paazl.PaazlDeliveryDateDetail[]; 
    Addresses : EVA.Carrier.Paazl.PaazlShippingAddress[]; 
    ShippingMethod : EVA.Core.ShippingMethodDto; 
  }
  
  export class PaazlUpdateShippingOptionsForOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    ShippingOption : EVA.Carrier.Paazl.PaazlShippingOption; 
  }
  
}