/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Cloe {
  
  export class CloeGetTrackingID extends EVA.API.RequestMessageGeneric<EVA.Cloe.CloeGetTrackingIDResponse> {
    SessionID : string; 
  }
  
  export class CloeGetTrackingIDResponse extends EVA.API.ResponseMessage {
    TrackingID : string; 
  }
  
  export class CloeTrackEvent extends EVA.API.RequestMessageWithEmptyResponse {
    TrackingID : string; 
    EventID : string; 
    Data : { [ key : string ] : any }; 
  }
  
  export class CloeUpdateProductFingerprints extends EVA.API.RequestMessageWithEmptyResponse {
    Fingerprints : EVA.Cloe.ProductFingerprint[]; 
  }
  
  export class ProductFingerprint {
    ProductID? : number; // Int32, nullable
    ProductIdentifier : string; 
    Fingerprint : string; 
  }
  
}