/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Intersolve {
  
  export class AddVoucherToShoppingCart extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    VoucherID : number; // Int64
  }
  
  export class ListVoucherConfigurations extends EVA.API.RequestMessageGeneric<EVA.Intersolve.ListVoucherConfigurationsResponse> {
  }
  
  export class ListVoucherConfigurationsResponse extends EVA.API.ResponseMessage {
    VoucherProviders : EVA.Intersolve.VoucherProvider[]; 
  }
  
  export class VoucherOption {
    Name : string; 
    VoucherID : number; // Int64
    EAN : string; 
    Value : number; // Decimal
    LayoutID : string; 
    Layout : string; 
    UnitCost : number; // Decimal
  }
  
  export class VoucherProvider {
    Options : EVA.Intersolve.VoucherOption[]; 
    Name : string; 
  }
  
}