/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.Rituals {
  
  export class Adjustedmerchandizetotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Adjustedshippingtotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class ArvatoCreatePurchaseOrderReceipt extends EVA.API.RequestMessageWithEmptyResponse {
    BackendOrderID : string; 
    PurchaseOrderLines : EVA.Rituals.ArvatoCreatePurchaseOrderReceiptLine[]; 
  }
  
  export class ArvatoCreatePurchaseOrderReceiptLine {
    BackendPurchaseOrderLineID : string; 
    Receipts : EVA.Rituals.ArvatoCreatePurchaseOrderReceiptLineReceipt[]; 
  }
  
  export class ArvatoCreatePurchaseOrderReceiptLineReceipt {
    QuantityReceived : number; // Int32
    StockLocationID : string; 
  }
  
  export class ArvatoCreateShipmentStatus extends EVA.API.RequestMessageWithEmptyResponse {
    Items : EVA.Rituals.ArvatoCreateShipmentStatusItem[]; 
  }
  
  export class ArvatoCreateStockMutation extends EVA.API.RequestMessageWithEmptyResponse {
    WarehouseID : string; 
    Mutations : EVA.Rituals.ArvatoStockMutation[]; 
  }
  
  export class ArvatoShipmentReceiptConfirmation extends EVA.API.RequestMessageWithEmptyResponse {
    WarehouseID : string; 
    BackendID : string; 
    Lines : EVA.Rituals.ArvatoShipmentReceiptConfirmationLine[]; 
  }
  
  export class ArvatoShipOrder extends EVA.API.RequestMessageWithEmptyResponse {
    ShippingConfirmations : EVA.Rituals.ArvatoShipOrderArvatoShipOrderConfirmation[]; 
  }
  
  export class ArvatoShipOrderArvatoShipOrderConfirmation {
    WarehouseID : string; 
    EvaOrderID : number; // Int32
    BackendOrderLineID : string; 
    DeliveryNumber : string; 
    DateShipped : string; // DateTime
    Packages : EVA.Rituals.ArvatoShipOrderArvatoShipOrderConfirmationArvatoShipOrderPackage[]; 
  }
  
  export class ArvatoShipOrderArvatoShipOrderConfirmationArvatoShipOrderPackage {
    TrackingCode : string; 
    TrackingUrl : string; 
    CarrierCode : string; 
    OrderLines : EVA.Rituals.ArvatoShipOrderArvatoShipOrderConfirmationArvatoShipOrderPackageOrderLine[]; 
  }
  
  export class ArvatoShipOrderArvatoShipOrderConfirmationArvatoShipOrderPackageOrderLine {
    EvaOrderLineID : number; // Int32
    BackendOrderLineID : string; 
    QuantityShipped : number; // Int32
    SerialNumber : string; 
  }
  
  export class ArvatoStockMutation {
    EAN : string; 
    Quantity : number; // Int32
    Type : string; 
    SourceStorageLocation : string; 
    DestinationStorageLocation : string; 
  }
  
  export class ArvatoUpdateOrder extends EVA.API.RequestMessageWithEmptyResponse {
    EvaOrderID : number; // Int32
    OrderLines : EVA.Rituals.ArvatoUpdateOrderLine[]; 
  }
  
  export class ArvatoUpdateOrderLine {
    EvaOrderLineID : number; // Int32
    IsCancelled : boolean; 
    IsPicked : boolean; 
    IsPacked : boolean; 
  }
  
  export class ArvatoUpdateStock extends EVA.API.RequestMessageWithEmptyResponse {
    WarehouseID : string; 
    Stock : EVA.Rituals.ArvatoUpdateStockLine[]; 
  }
  
  export class ArvatoUpdateStockLine {
    EAN : string; 
    QuantityAvailable : number; // Int32
  }
  
  export enum AssetType {
    None = 0,
    PrimaryImage = 1,
    EcomPrimaryImage = 2,
    EcomSecondaryImage = 4,
    EcomGridImage = 8,
    EcomHowToUseMobileImage = 16,
  }
  
  export class Billingaddress implements EVA.Rituals.IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Secondname : string; 
    Lastname : string; 
    Companyname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Productlineitem implements EVA.Rituals.IDemandwarePrices {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Position : string; 
    Productid : string; 
    Productname : string; 
    Quantity : EVA.Rituals.Quantity; 
    Taxrate : string; 
    Shipmentid : string; 
    Options : EVA.Rituals.Optionlineitems; 
    BundledProductLines : EVA.Rituals.BundledProductLineItems; 
    Gift : string; 
    GiftMessage : string; 
    Customattributes : EVA.Rituals.Customattributes; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class BundledProductLineItem extends EVA.Rituals.Productlineitem {
  }
  
  export class BundledProductLineItems {
    BundledProductLine : EVA.Rituals.BundledProductLineItem[]; 
  }
  
  export class CreateDemandwareOrders extends EVA.API.RequestMessageGeneric<EVA.Rituals.CreateDemandwareOrdersResponse> {
    Orders : EVA.Rituals.DemandwareOrders; 
  }
  
  export class CreateDemandwareOrdersResponse extends EVA.API.ResponseMessage {
    OrderSets : EVA.Rituals.CreateDemandwareOrdersResponseOrderSetsModel; 
  }
  
  export class CreateMeaningfulMoment extends EVA.API.RequestMessageGeneric<EVA.Rituals.CreateMeaningfulMomentResponse> {
    Date : string; // DateTime
    Reminder? : string; // DateTime, nullable
    Type : string; 
    RecipientName : string; 
    RecipientEmailAddress : string; 
    Occasion : string; 
    ImageUrl : string; 
    IconUrl : string; 
  }
  
  export class CreateMeaningfulMomentOrder extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    MeaningfulMomentID : number; // Int32
  }
  
  export class CreateMeaningfulMomentResponse extends EVA.API.CreateResponse {
  }
  
  export class Customattribute {
    Attributeid : string; 
    Text : string; 
  }
  
  export class Customattributes {
    Customattribute : EVA.Rituals.Customattribute[]; 
  }
  
  export class Customer {
    CustomerNo : string; 
    Customername : string; 
    Customeremail : string; 
    Billingaddress : EVA.Rituals.Billingaddress; 
  }
  
  export class Custommethod {
    Methodname : string; 
  }
  
  export class DeleteMeaningfulMoment extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
  }
  
  export class DemandwareOrders {
    Order : EVA.Rituals.Order[]; 
  }
  
  export class GetMeaningfulMoment extends EVA.API.GetRequestGeneric<EVA.Rituals.GetMeaningfulMomentResponse> {
  }
  
  export class GetMeaningfulMomentGreetingCard extends EVA.API.RequestMessageGeneric<EVA.Rituals.MeaningfulMomentGreetingCardResponse> {
    OrderID : number; // Int32
  }
  
  export class GetMeaningfulMomentMedia extends EVA.API.RequestMessageGeneric<EVA.Rituals.MeaningfulMomentMediaResponse> {
    OrderID : number; // Int32
    Type : string; 
  }
  
  export class GetMeaningfulMomentResponse extends EVA.API.GetResponse<EVA.Rituals.GetMeaningfulMomentResponseModel> {
  }
  
  export class GetMeaningfulMomentSurprises extends EVA.API.RequestMessageGeneric<EVA.Rituals.GetMeaningfulMomentSurprisesResponse> {
    OrderID : number; // Int32
  }
  
  export class GetMeaningfulMomentSurprisesResponse extends EVA.API.ResponseMessage {
    Surprises : string[]; 
  }
  
  export class GoogleBackfill extends EVA.API.RequestMessageGeneric<EVA.Rituals.GoogleBackfillResponse> {
    Type : EVA.Rituals.GoogleBackfillTypes; 
    From : string; // DateTime
    To : string; // DateTime
    Limit? : number; // Int32, nullable
    Batch? : number; // Int32, nullable
    Expire? : number; // Int32, nullable
    Preview : boolean; 
  }
  
  export class GoogleBackfillResponse extends EVA.API.ResponseMessage {
    EmailAddress : string; 
    Count : number; // Int32
  }
  
  export enum GoogleBackfillTypes {
    SalesOrders = 0,
    PurchaseOrders = 1,
    Interbranch = 2,
    CycleCounts = 3,
  }
  
  export class HerokuConfirmOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    ClientID : string; 
    Text : string; 
  }
  
  export interface IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Lastname : string; 
    Secondname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Companyname : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export interface IDemandwarePrices {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Taxbasis : string; 
  }
  
  export interface ISOSTokenRequest {
    Token : string; 
  }
  
  export class ArvatoCreateShipmentStatusItem {
    OrderID : string; 
    CurrentStatus : EVA.Rituals.ArvatoCreateShipmentStatusStatus; 
  }
  
  export class ArvatoShipmentReceiptConfirmationLine {
    QuantityReceived : number; // Int32
    EAN : string; 
  }
  
  export class RitualsUpdateReturnOrderLine {
    CustomID : string; 
    Quantity : number; // Int32
  }
  
  export class RitualsCreateCustomerReturnLineModel {
    ID : number; // Int32
    QuantityToReturn : number; // Int32
    Reason : string; 
  }
  
  export class ListMeaningfulMomentOrders extends EVA.API.RequestMessageGeneric<EVA.Rituals.ListMeaningfulMomentOrdersResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Rituals.ListMeaningfulMomentOrdersFilter>; 
  }
  
  export class ListMeaningfulMomentOrdersFilter {
    CreatedByID : number; // Int32
    MeaningfulMomentID : number; // Int32
  }
  
  export class ListMeaningfulMomentOrdersResponse extends EVA.API.PagedResultResponse<EVA.Rituals.ListMeaningfulMomentOrdersResponseModel> {
  }
  
  export class ListMeaningfulMoments extends EVA.API.RequestMessageGeneric<EVA.Rituals.ListMeaningfulMomentsResponse> {
    PageConfig : EVA.Framework.PageConfigGeneric<EVA.Rituals.ListMeaningfulMomentsFilter>; 
  }
  
  export class ListMeaningfulMomentsFilter {
    CreatedByID : number; // Int32
    StartTriggerDate? : string; // DateTime, nullable
    EndTriggerDate? : string; // DateTime, nullable
  }
  
  export class ListMeaningfulMomentsResponse extends EVA.API.PagedResultResponse<EVA.Rituals.ListMeaningfulMomentsResponseModel> {
  }
  
  export class MeaningfulMomentGreetingCardResponse extends EVA.API.ResponseMessage {
    ImageUrl : string; 
    Text : string; 
  }
  
  export class MeaningfulMomentMediaResponse extends EVA.API.ResponseMessage {
    Type : string; 
    Title : string; 
    CoverUrl : string; 
    MediaUrl : string; 
  }
  
  export class Merchandizetotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class GetMeaningfulMomentResponseModel {
    ID : number; // Int32
    Date : string; // DateTime
    Reminder? : string; // DateTime, nullable
    Type : string; 
    RecipientName : string; 
    RecipientEmailAddress : string; 
    Occasion : string; 
    ImageUrl : string; 
    IconUrl : string; 
    Tokens : EVA.Framework.Token[]; 
  }
  
  export class ListMeaningfulMomentOrdersResponseModel {
    OrderID : number; // Int32
    CreationTime : string; // DateTime
  }
  
  export class ListMeaningfulMomentsResponseModel {
    ID : number; // Int32
    Date : string; // DateTime
    Reminder? : string; // DateTime, nullable
    Type : string; 
    RecipientName : string; 
    RecipientEmailAddress : string; 
    Occasion : string; 
    ImageUrl : string; 
    IconUrl : string; 
  }
  
  export class RitualsGetBlobsForReturnResponseModel {
    Name : string; 
    MimeType : string; 
    BlobID : string; 
    Url : string; 
  }
  
  export class RitualsListAvailablePickupStoresResponseModel {
    ID : number; // Int32
    BackendID : string; 
    Name : string; 
    Address : EVA.Core.AddressDto; 
    Latitude : number; // Double
    Longitude : number; // Double
    EmailAddress : string; 
    PhoneNumber : string; 
    EstimatedPickupTime : string; // DateTime
    TimeZone : string; 
    MerchantID : string; 
    OpeningHours : EVA.Rituals.RitualsListAvailablePickupStoresResponseOpeningHour[]; 
    DistanceInKm : number; // Double
    DistanceInMiles : number; // Double
  }
  
  export class Note {
    Subject : string; 
    Text : string; 
  }
  
  export class Notes {
    Note : EVA.Rituals.Note[]; 
  }
  
  export class RitualsListAvailablePickupStoresResponseOpeningHour {
    DayOfWeek : string; 
    StartTime : any; // TimeSpan
    EndTime : any; // TimeSpan
    Date? : string; // DateTime, nullable
  }
  
  export class OptionLineItem {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    OptionId : string; 
    ValueId : string; 
    ProductId : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Optionlineitems {
    Items : EVA.Rituals.OptionLineItem[]; 
  }
  
  export class Order {
    Orderdate : string; 
    Createdby : string; 
    Originalorderno : string; 
    Currency : string; 
    Customerlocale : string; 
    Taxation : string; 
    Invoiceno : string; 
    Customer : EVA.Rituals.Customer; 
    Status : EVA.Rituals.Status; 
    Currentorderno : string; 
    Productlineitems : EVA.Rituals.Productlineitems; 
    Shippinglineitems : EVA.Rituals.Shippinglineitems; 
    Shipments : EVA.Rituals.Shipments; 
    Totals : EVA.Rituals.Totals; 
    Payments : EVA.Rituals.Payments; 
    Notes : EVA.Rituals.Notes; 
    Customattributes : EVA.Rituals.Customattributes; 
    Orderno : string; 
  }
  
  export class RitualsGetOrderForReturnResponseOrderLineModel {
    ReturnableQuantity : number; // Int32
    IsReturnable : boolean; 
    ID : number; // Int32
    Type : EVA.Core.OrderLineTypes; 
    Description : string; 
    ParentID? : number; // Int32, nullable
    ProductID? : number; // Int32, nullable
    ProductVariation : { [ key : string ] : string }; 
    QuantityCancelled : number; // Int32
    QuantityOrdered : number; // Int32
    QuantityShipped : number; // Int32
    UnitPrice : number; // Decimal
    UnitPriceInTax : number; // Decimal
    TaxRate : number; // Decimal
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    CurrencyID : string; 
  }
  
  export class RitualsGetOrderForReturnResponseOrderLinesReturnSet {
    OrderLineIDs : number[]; 
    RequiredOrderLineIDsToReturn : number[]; 
  }
  
  export class RitualsGetOrderForReturnResponseOrderModel {
    ID : number; // Int32
    Lines : EVA.Rituals.RitualsGetOrderForReturnResponseOrderLineModel[]; 
    CustomerID : number; // Int32
    CreationTime : string; // DateTime
    InvoiceNumbers : string[]; 
    ReturnSets : EVA.Rituals.RitualsGetOrderForReturnResponseOrderLinesReturnSet[]; 
  }
  
  export class CreateDemandwareOrdersResponseOrderSetModel {
    EVAOrderID : number; // Int32
    DemandwareOrderNo : string; 
  }
  
  export class CreateDemandwareOrdersResponseOrderSetsModel {
    OrderSet : EVA.Rituals.CreateDemandwareOrdersResponseOrderSetModel[]; 
  }
  
  export class Ordertotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class RitualsBIGetStoresForUserResponseOrganizationUnit {
    ID : number; // Int32
    Name : string; 
    TypeID : EVA.Rituals.Type; 
    ViewReports : boolean; 
    Children : EVA.Rituals.RitualsBIGetStoresForUserResponseOrganizationUnit[]; 
  }
  
  export class Payment {
    Custommethod : EVA.Rituals.Custommethod; 
    Amount : string; 
    Processorid : string; 
    Transactionid : string; 
  }
  
  export class Payments {
    Payment : EVA.Rituals.Payment[]; 
  }
  
  export enum PlatformTypes {
    Facebook = 0,
    WhatsApp = 1,
  }
  
  export class Priceadjustment {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Promotionid : string; 
    Campaignid : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Priceadjustments {
    Priceadjustment : EVA.Rituals.Priceadjustment[]; 
  }
  
  export class RitualsListAvailablePickupStoresProduct {
    Consumercode : string; 
    Quantity : number; // Int32
  }
  
  export class Productlineitems {
    Productlineitem : EVA.Rituals.Productlineitem[]; 
  }
  
  export class Quantity {
    Unit : string; 
    Text : string; 
  }
  
  export class RitualsAddGiftCardToOrder extends EVA.API.RequestMessageWithEmptyResponse {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Amount : number; // Decimal
    Data : EVA.Rituals.RitualsGiftCardData; 
  }
  
  export class RitualsAddProductVoucher extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderID : number; // Int32
  }
  
  export class RitualsAttachCustomerToOrder extends EVA.API.RequestMessageWithEmptyResponse implements EVA.Rituals.ISOSTokenRequest {
    Token : string; 
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    Gender : string; 
    BillingAddress : EVA.Core.AddressDataDto; 
    ShippingAddress : EVA.Core.AddressDataDto; 
    GreetingCard : string; 
  }
  
  export class RitualsBIGetStoresForUser extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsBIGetStoresForUserResponse> {
  }
  
  export class RitualsBIGetStoresForUserResponse extends EVA.API.ResponseMessage {
    Root : EVA.Rituals.RitualsBIGetStoresForUserResponseOrganizationUnit; 
  }
  
  export class RitualsCreateCustomerReturn extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsCreateCustomerReturnResponse> {
    OrderID : number; // Int32
    Email : string; 
    TargetOrderID? : number; // Int32, nullable
    SessionID : string; 
    Lines : EVA.Rituals.RitualsCreateCustomerReturnLineModel[]; 
  }
  
  export class RitualsCreateCustomerReturnResponse extends EVA.API.ResponseMessage {
    OrderID : number; // Int32
  }
  
  export class RitualsDownloadGiftCard extends EVA.API.RequestMessageWithResourceResponse {
    OrderID? : number; // Int32, nullable
    AccessToken : string; 
    GiftCardID : string; 
    LanguageID : string; 
  }
  
  export class RitualsGeneratePassbookPass extends EVA.API.RequestMessageWithResourceResponse {
    OrderID? : number; // Int32, nullable
    AccessToken : string; 
    GiftCardID : string; 
  }
  
  export class RitualsGetBlobsForReturn extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetBlobsForReturnResponse> {
    OrderID : number; // Int32
    Email : string; 
  }
  
  export class RitualsGetBlobsForReturnResponse extends EVA.API.ResponseMessage {
    Result : EVA.Rituals.RitualsGetBlobsForReturnResponseModel[]; 
  }
  
  export class RitualsGetCartData extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetCartDataResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
  }
  
  export class RitualsGetCartDataResponse extends EVA.API.ResponseMessage {
    Data : EVA.Rituals.SOSOrderData; 
  }
  
  export class RitualsGetCustomerData extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetCustomerDataResponse> implements EVA.Rituals.ISOSTokenRequest {
    Token : string; 
  }
  
  export class RitualsGetCustomerDataResponse extends EVA.API.ResponseMessage {
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
    Gender : string; 
    BillingAddress : EVA.Core.AddressDataDto; 
    ShippingAddress : EVA.Core.AddressDataDto; 
    CountryID : string; 
    LanguageID : string; 
    Data : EVA.Rituals.SOSOrderData; 
  }
  
  export class RitualsGetDeliveryOrderData extends EVA.API.RequestMessageGeneric<EVA.Core.Services.GetDeliveryOrderDataResponse> implements EVA.Rituals.ISOSTokenRequest {
    Token : string; 
  }
  
  export class RitualsGetGiftCardForOrder extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetGiftCardForOrderResponse> {
    OrderID? : number; // Int32, nullable
    AccessToken : string; 
    GiftCardID : string; 
  }
  
  export class RitualsGetGiftCardForOrderResponse extends EVA.API.GetListResponse<EVA.Rituals.RitualsGiftCard> {
  }
  
  export class RitualsGetGiftCardMailOptions extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetGiftCardMailOptionsResponse> {
    OrderID? : number; // Int32, nullable
    GiftCardID : string; 
    AccessToken : string; 
  }
  
  export class RitualsGetGiftCardMailOptionsResponse extends EVA.API.ResponseMessage {
    FromEmailAddress : string; 
    ToEmailAddress : string; 
    DeliverySchedule? : string; // DateTime, nullable
    CanBeUpdated : boolean; 
  }
  
  export class RitualsGetOrderForReturn extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetOrderForReturnResponse> {
    OrderID : string; 
    Email : string; 
  }
  
  export class RitualsGetOrderForReturnResponse extends EVA.API.ResponseMessage {
    Result : EVA.Rituals.RitualsGetOrderForReturnResponseOrderModel; 
  }
  
  export class RitualsGetProductVoucher extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetProductVoucherResponse> {
    IncludedProperties : string[]; 
  }
  
  export class RitualsGetProductVoucherResponse extends EVA.API.ResponseMessage {
    Product : any; 
  }
  
  export class RitualsGetUserDataForUser extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsGetUserDataForUserResponse> {
    UserID? : number; // Int32, nullable
  }
  
  export class RitualsGetUserDataForUserResponse extends EVA.API.ResponseMessage {
    ContactID : string; 
    LoyaltyID : string; 
    LoyaltyEnabled : boolean; 
    CanRedeemWelcomeGift : boolean; 
  }
  
  export class RitualsGiftCard {
    IsAvailable : boolean; 
    Amount : number; // Decimal
    CurrencyID : string; 
    Identifiers : EVA.Rituals.RitualsGiftCardIdentifiers; 
    Data : EVA.Rituals.RitualsGiftCardData; 
    Details : EVA.Rituals.RitualsGiftCardDetails; 
  }
  
  export class RitualsGiftCardData {
    Theme : EVA.Rituals.RitualsGiftCardTheme; 
    From : string; 
    To : string; 
    Text : string; 
    FromEmailAddress : string; 
    ToEmailAddress : string; 
    DeliverySchedule? : string; // DateTime, nullable
    UpdateUrl : string; 
    UpdateToken : string; 
  }
  
  export class RitualsGiftCardDetails {
    GiftCardNumber : string; 
    PIN : string; 
  }
  
  export class RitualsGiftCardIdentifiers {
    OrderID : number; // Int32
    OrderLineID : number; // Int32
    AccessToken : string; 
    GiftCardID : string; 
  }
  
  export class RitualsGiftCardTheme {
    ID : string; 
    Name : string; 
    Description : string; 
    LongDescription : string; 
    ForegroundColor : string; 
    BackgroundColor : string; 
    ImageUrl : string; 
    ImageWidth : number; // Int32
    ImageHeight : number; // Int32
    VideoUrl : string; 
    StillUrl : string; 
  }
  
  export class RitualsListAvailablePickupStores extends EVA.API.PagedResultRequest<EVA.Rituals.RitualsListAvailablePickupStoresResponse> {
    Products : EVA.Rituals.RitualsListAvailablePickupStoresProduct[]; 
  }
  
  export class RitualsListAvailablePickupStoresResponse extends EVA.API.PagedResultResponse<EVA.Rituals.RitualsListAvailablePickupStoresResponseModel> {
  }
  
  export class RitualsPaazlGetShippingOptionsForOrder extends EVA.API.RequestMessageGeneric<EVA.Carrier.Paazl.PaazlGetShippingOptionsForOrderResponse> implements EVA.Rituals.ISOSTokenRequest {
    Token : string; 
    ExtendedDeliveryDateDetails : boolean; 
  }
  
  export class RitualsPaazlUpdateShippingOptionsForOrder extends EVA.API.RequestMessageWithEmptyResponse implements EVA.Rituals.ISOSTokenRequest {
    Token : string; 
    ShippingOption : EVA.Carrier.Paazl.PaazlShippingOption; 
  }
  
  export class RitualsPushOrderToGoogle extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Status : string; 
  }
  
  export class RitualsRemoveProductVoucher extends EVA.API.RequestMessageGeneric<EVA.Core.SimpleShoppingCartResponse> {
    OrderID : number; // Int32
  }
  
  export class RitualsRequestPrivacyRemoval extends EVA.API.RequestMessageGeneric<EVA.Privacy.CreatePrivacyRemovalRequestResponse> {
    UserID : number; // Int32
  }
  
  export class RitualsScanLoyaltyCard extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsScanLoyaltyCardResponse> {
    LoyaltyID : string; 
  }
  
  export class RitualsScanLoyaltyCardResponse extends EVA.API.ResponseMessage {
    User : EVA.Core.UserDto; 
  }
  
  export class RitualsSendAddressFormLinkFromCart extends EVA.API.RequestMessageGeneric<EVA.Rituals.SOSUrlResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Text : string; 
    Url : string; 
  }
  
  export class RitualsSendCarouselFromCart extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    OrderLineIDs : number[]; 
  }
  
  export class RitualsSendGiftCardByMail extends EVA.API.RequestMessageGeneric<EVA.Rituals.RitualsSendGiftCardByMailResponse> {
    OrderID : number; // Int32
    GiftCardID : string; 
    FromEmailAddress : string; 
    ToEmailAddress : string; 
    DeliverySchedule? : string; // DateTime, nullable
    UpdateUrl : string; 
  }
  
  export class RitualsSendGiftCardByMailResponse extends EVA.API.ResponseMessage {
    Token : string; 
  }
  
  export class RitualsSendPaazlLinkFromCart extends EVA.API.RequestMessageGeneric<EVA.Rituals.SOSUrlResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Text : string; 
    Url : string; 
  }
  
  export class RitualsSendPaymentLinkFromCart extends EVA.API.RequestMessageGeneric<EVA.Rituals.SOSUrlResponse> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Text : string; 
    Url : string; 
  }
  
  export class RitualsSendReceiptFromCart extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    IsSummary : boolean; 
    Text : string; 
  }
  
  export class RitualsSetCartData extends EVA.API.RequestMessageGeneric<EVA.API.EmptyResponseMessage> {
    SessionID : string; 
    OrderID? : number; // Int32, nullable
    Data : EVA.Rituals.SOSOrderData; 
  }
  
  export class RitualsUpdateGiftCardMailOptions extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID? : number; // Int32, nullable
    GiftCardID : string; 
    FromEmailAddress : string; 
    ToEmailAddress : string; 
    DeliverySchedule? : string; // DateTime, nullable
    AccessToken : string; 
  }
  
  export class RitualsUpdateLoyalty extends EVA.API.RequestMessageWithEmptyResponse {
    UserID? : number; // Int32, nullable
    Enabled : boolean; 
  }
  
  export class RitualsUpdateReturnOrder extends EVA.API.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    ReturnReasonCode : string; 
    ExpectedPickupDate? : string; // DateTime, nullable
    Lines : EVA.Rituals.RitualsUpdateReturnOrderLine[]; 
  }
  
  export class SetMeaningfulMomentGreetingCard extends EVA.API.RequestMessageGeneric<EVA.Rituals.MeaningfulMomentGreetingCardResponse> {
    OrderID : number; // Int32
    ImageUrl : string; 
    Text : string; 
  }
  
  export class SetMeaningfulMomentMedia extends EVA.API.RequestMessageGeneric<EVA.Rituals.MeaningfulMomentMediaResponse> {
    OrderID : number; // Int32
    Type : string; 
    Title : string; 
    CoverUrl : string; 
    MediaUrl : string; 
  }
  
  export class Shipment {
    Status : EVA.Rituals.Status; 
    Shippingmethod : string; 
    Shippingaddress : EVA.Rituals.Shippingaddress; 
    Gift : string; 
    GiftMessage : string; 
    Totals : EVA.Rituals.Totals; 
    Shipmentid : string; 
  }
  
  export class Shipments {
    Shipment : EVA.Rituals.Shipment[]; 
  }
  
  export class Shipmenttotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Shippingaddress implements EVA.Rituals.IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Secondname : string; 
    Lastname : string; 
    Companyname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Shippinglineitem implements EVA.Rituals.IDemandwarePrices {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Itemid : string; 
    Shipmentid : string; 
    Taxrate : string; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class Shippinglineitems {
    Shippinglineitem : EVA.Rituals.Shippinglineitem[]; 
  }
  
  export class Shippingtotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class SOSOrderData {
    ClientID : string; 
    PlatformID : string; 
    PlatformType : EVA.Rituals.PlatformTypes; 
    PaymentReminderSent : boolean; 
    Data : any; 
  }
  
  export class SOSUrlResponse extends EVA.API.ResponseMessage {
    Success : boolean; 
    ErrorMessage : string; 
    Message : string; 
    Url : string; 
  }
  
  export class ArvatoCreateShipmentStatusStatus {
    Date : string; // DateTime
    CarrierCode : string; 
    Description : string; 
  }
  
  export class Status {
    Orderstatus : string; 
    Shippingstatus : string; 
    Confirmationstatus : string; 
    Paymentstatus : string; 
  }
  
  export class Totals {
    Merchandizetotal : EVA.Rituals.Merchandizetotal; 
    Adjustedmerchandizetotal : EVA.Rituals.Adjustedmerchandizetotal; 
    Shippingtotal : EVA.Rituals.Shippingtotal; 
    Adjustedshippingtotal : EVA.Rituals.Adjustedshippingtotal; 
    Shipmenttotal : EVA.Rituals.Shipmenttotal; 
    Ordertotal : EVA.Rituals.Ordertotal; 
  }
  
  export enum Type {
    None = 0,
    Shop = 1,
    City = 2,
    Region = 3,
    Country = 4,
    Root = 5,
  }
  
  export class UpdateMeaningfulMoment extends EVA.API.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Date : string; // DateTime
    Reminder? : string; // DateTime, nullable
    Type : string; 
    RecipientName : string; 
    RecipientEmailAddress : string; 
    Occasion : string; 
    ImageUrl : string; 
    IconUrl : string; 
  }
  
}